Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/Makefile.deps
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/Makefile.deps	(revision 115)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/Makefile.deps	(revision 116)
@@ -16,4 +16,7 @@
 include 			$(DIR_MORPHEO)/Behavioural/Custom/Makefile.deps
 endif
+ifndef Shifter
+include 			$(DIR_MORPHEO)/Behavioural/Generic/Shifter/Makefile.deps
+endif
 
 #-----[ Library ]------------------------------------------
@@ -21,15 +24,20 @@
 					$(Custom_LIBRARY)	\
 					-lFunctionnal_unit	\
-					$(Behavioural_LIBRARY)	
+					$(Behavioural_LIBRARY)	\
+					-lFunctionnal_unit	\
+					$(Shifter_LIBRARY)	
 
 Functionnal_unit_DIR_LIBRARY	=	-L$(DIR_MORPHEO)/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/lib	\
-					$(Custom_DIR_LIBRARY)	\
-					$(Behavioural_DIR_LIBRARY)
+					$(Custom_DIR_LIBRARY)	   \
+					$(Behavioural_DIR_LIBRARY) \
+					$(Shifter_DIR_LIBRARY)
 
-Functionnal_unit_DEPENDENCIES	=	Custom_library	\
-					Behavioural_library
+Functionnal_unit_DEPENDENCIES	=	Custom_library          \
+					Behavioural_library     \
+                                        Shifter_library
 
-Functionnal_unit_CLEAN        	=	Custom_library_clean	\
-					Behavioural_library_clean
+Functionnal_unit_CLEAN        	=	Custom_library_clean      \
+					Behavioural_library_clean \
+                                        Shifter_library_clean
 
 #-----[ Rules ]--------------------------------------------
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/Operation/include/Operation.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/Operation/include/Operation.h	(revision 115)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/Operation/include/Operation.h	(revision 116)
@@ -1,4 +1,4 @@
-#ifndef morpheo_behavioural_core_multi_execute_loop_execute_loop_multi_execute_unit_execute_unit_functionnal_unit_operation_h
-#define morpheo_behavioural_core_multi_execute_loop_execute_loop_multi_execute_unit_execute_unit_functionnal_unit_operation_h
+#ifndef morpheo_behavioural_core_multi_execute_loop_execute_loop_multi_execute_unit_execute_unit_functionnal_unit_operation_Operation_h
+#define morpheo_behavioural_core_multi_execute_loop_execute_loop_multi_execute_unit_execute_unit_functionnal_unit_operation_Operation_h
 
 /*
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/Operation/include/Types.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/Operation/include/Types.h	(revision 115)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/Operation/include/Types.h	(revision 116)
@@ -1,4 +1,4 @@
-#ifndef morpheo_behavioural_core_multi_execute_loop_execute_loop_multi_execute_unit_execute_unit_functionnal_unit_Types_h
-#define morpheo_behavioural_core_multi_execute_loop_execute_loop_multi_execute_unit_execute_unit_functionnal_unit_Types_h
+#ifndef morpheo_behavioural_core_multi_execute_loop_execute_loop_multi_execute_unit_execute_unit_functionnal_unit_operation_Types_h
+#define morpheo_behavioural_core_multi_execute_loop_execute_loop_multi_execute_unit_execute_unit_functionnal_unit_operation_Types_h
 
 /*
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/Operation/src/Operation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/Operation/src/Operation.cpp	(revision 115)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/Operation/src/Operation.cpp	(revision 116)
@@ -50,5 +50,9 @@
     op->_exception    = (overflow==1)?EXCEPTION_ALU_RANGE:EXCEPTION_ALU_NONE;
     op->_no_sequence  = 0;
-  //op->_address      = 0;
+#ifdef SYSTEMC_VHDL_COMPATIBILITY
+    op->_address      = 0;
+#else
+  //op->_address      = 0;
+#endif
   };
 
@@ -76,5 +80,9 @@
     op->_exception    = (overflow==1)?EXCEPTION_ALU_RANGE:EXCEPTION_ALU_NONE;
     op->_no_sequence  = 0;
-  //op->_address      = 0;
+#ifdef SYSTEMC_VHDL_COMPATIBILITY
+    op->_address      = 0;
+#else
+  //op->_address      = 0;
+#endif
   };
 
@@ -102,5 +110,9 @@
     op->_exception    = (overflow==1)?EXCEPTION_ALU_RANGE:EXCEPTION_ALU_NONE;
     op->_no_sequence  = 0;
-  //op->_address      = 0;
+#ifdef SYSTEMC_VHDL_COMPATIBILITY
+    op->_address      = 0;
+#else
+  //op->_address      = 0;
+#endif
   };
 
@@ -140,5 +152,9 @@
     op->_exception    = (overflow==1)?EXCEPTION_ALU_RANGE:EXCEPTION_ALU_NONE;
     op->_no_sequence  = 0;
-  //op->_address      = 0;
+#ifdef SYSTEMC_VHDL_COMPATIBILITY
+    op->_address      = 0;
+#else
+  //op->_address      = 0;
+#endif
   };
 
@@ -178,5 +194,9 @@
     op->_exception    = (overflow==1)?EXCEPTION_ALU_RANGE:EXCEPTION_ALU_NONE;
     op->_no_sequence  = 0;
-  //op->_address      = 0;
+#ifdef SYSTEMC_VHDL_COMPATIBILITY
+    op->_address      = 0;
+#else
+  //op->_address      = 0;
+#endif
   };
 
@@ -201,5 +221,9 @@
     op->_exception    = (overflow==1)?EXCEPTION_ALU_RANGE:EXCEPTION_ALU_NONE;
     op->_no_sequence  = 0;
-  //op->_address      = 0;
+#ifdef SYSTEMC_VHDL_COMPATIBILITY
+    op->_address      = 0;
+#else
+  //op->_address      = 0;
+#endif
   };
 
@@ -224,5 +248,9 @@
     op->_exception    = (overflow==1)?EXCEPTION_ALU_RANGE:EXCEPTION_ALU_NONE;
     op->_no_sequence  = 0;
-  //op->_address      = 0;
+#ifdef SYSTEMC_VHDL_COMPATIBILITY
+    op->_address      = 0;
+#else
+  //op->_address      = 0;
+#endif
   };
 
@@ -243,5 +271,9 @@
     op->_exception    = EXCEPTION_ALU_NONE;
     op->_no_sequence  = 0;
-  //op->_address      = 0;
+#ifdef SYSTEMC_VHDL_COMPATIBILITY
+    op->_address      = 0;
+#else
+  //op->_address      = 0;
+#endif
   };
 
@@ -262,5 +294,9 @@
     op->_exception    = EXCEPTION_ALU_NONE;
     op->_no_sequence  = 0;
-  //op->_address      = 0;
+#ifdef SYSTEMC_VHDL_COMPATIBILITY
+    op->_address      = 0;
+#else
+  //op->_address      = 0;
+#endif
   };
 
@@ -281,5 +317,9 @@
     op->_exception    = EXCEPTION_ALU_NONE;
     op->_no_sequence  = 0;
-  //op->_address      = 0;
+#ifdef SYSTEMC_VHDL_COMPATIBILITY
+    op->_address      = 0;
+#else
+  //op->_address      = 0;
+#endif
   };
 
@@ -299,5 +339,9 @@
     op->_exception    = EXCEPTION_ALU_NONE;
     op->_no_sequence  = 0;
-  //op->_address      = 0;
+#ifdef SYSTEMC_VHDL_COMPATIBILITY
+    op->_address      = 0;
+#else
+  //op->_address      = 0;
+#endif
   };
 
@@ -320,5 +364,9 @@
     op->_exception    = EXCEPTION_ALU_NONE;
     op->_no_sequence  = 0;
-  //op->_address      = 0;
+#ifdef SYSTEMC_VHDL_COMPATIBILITY
+    op->_address      = 0;
+#else
+  //op->_address      = 0;
+#endif
   };
 
@@ -402,5 +450,9 @@
     op->_exception    = EXCEPTION_ALU_NONE;
     op->_no_sequence  = 0;
-  //op->_address      = 0;
+#ifdef SYSTEMC_VHDL_COMPATIBILITY
+    op->_address      = 0;
+#else
+  //op->_address      = 0;
+#endif
   };
 
@@ -421,5 +473,9 @@
     op->_exception    = EXCEPTION_ALU_NONE;
     op->_no_sequence  = 0;
-  //op->_address      = 0;
+#ifdef SYSTEMC_VHDL_COMPATIBILITY
+    op->_address      = 0;
+#else
+  //op->_address      = 0;
+#endif
   };
 
@@ -440,5 +496,9 @@
     op->_exception    = EXCEPTION_ALU_NONE;
     op->_no_sequence  = 0;
-  //op->_address      = 0;
+#ifdef SYSTEMC_VHDL_COMPATIBILITY
+    op->_address      = 0;
+#else
+  //op->_address      = 0;
+#endif
   };
 
@@ -459,5 +519,9 @@
     op->_exception    = EXCEPTION_ALU_NONE;
     op->_no_sequence  = 0;
-  //op->_address      = 0;
+#ifdef SYSTEMC_VHDL_COMPATIBILITY
+    op->_address      = 0;
+#else
+  //op->_address      = 0;
+#endif
   };
 
@@ -478,5 +542,9 @@
     op->_exception    = EXCEPTION_ALU_NONE;
     op->_no_sequence  = 0;
-  //op->_address      = 0;
+#ifdef SYSTEMC_VHDL_COMPATIBILITY
+    op->_address      = 0;
+#else
+  //op->_address      = 0;
+#endif
   };
 
@@ -497,5 +565,9 @@
     op->_exception    = EXCEPTION_ALU_NONE;
     op->_no_sequence  = 0;
-  //op->_address      = 0;
+#ifdef SYSTEMC_VHDL_COMPATIBILITY
+    op->_address      = 0;
+#else
+  //op->_address      = 0;
+#endif
   };
 
@@ -517,5 +589,9 @@
     op->_exception    = EXCEPTION_ALU_NONE;
     op->_no_sequence  = 0;
-  //op->_address      = 0;
+#ifdef SYSTEMC_VHDL_COMPATIBILITY
+    op->_address      = 0;
+#else
+  //op->_address      = 0;
+#endif
   };
 
@@ -537,5 +613,9 @@
     op->_exception    = EXCEPTION_ALU_NONE;
     op->_no_sequence  = 0;
-  //op->_address      = 0;
+#ifdef SYSTEMC_VHDL_COMPATIBILITY
+    op->_address      = 0;
+#else
+  //op->_address      = 0;
+#endif
   };
 
@@ -557,5 +637,9 @@
     op->_exception    = EXCEPTION_ALU_NONE;
     op->_no_sequence  = 0;
-  //op->_address      = 0;
+#ifdef SYSTEMC_VHDL_COMPATIBILITY
+    op->_address      = 0;
+#else
+  //op->_address      = 0;
+#endif
   };
 
@@ -577,5 +661,9 @@
     op->_exception    = EXCEPTION_ALU_NONE;
     op->_no_sequence  = 0;
-  //op->_address      = 0;
+#ifdef SYSTEMC_VHDL_COMPATIBILITY
+    op->_address      = 0;
+#else
+  //op->_address      = 0;
+#endif
   };
 
@@ -598,5 +686,9 @@
     op->_exception    = EXCEPTION_ALU_NONE;
     op->_no_sequence  = 0;
-  //op->_address      = 0;
+#ifdef SYSTEMC_VHDL_COMPATIBILITY
+    op->_address      = 0;
+#else
+  //op->_address      = 0;
+#endif
   };
 
@@ -619,5 +711,9 @@
     op->_exception    = EXCEPTION_ALU_NONE;
     op->_no_sequence  = 0;
-  //op->_address      = 0;
+#ifdef SYSTEMC_VHDL_COMPATIBILITY
+    op->_address      = 0;
+#else
+  //op->_address      = 0;
+#endif
   };
 
@@ -640,5 +736,9 @@
     op->_exception    = EXCEPTION_ALU_NONE;
     op->_no_sequence  = 0;
-  //op->_address      = 0;
+#ifdef SYSTEMC_VHDL_COMPATIBILITY
+    op->_address      = 0;
+#else
+  //op->_address      = 0;
+#endif
   };
 
@@ -661,5 +761,9 @@
     op->_exception    = EXCEPTION_ALU_NONE;
     op->_no_sequence  = 0;
-  //op->_address      = 0;
+#ifdef SYSTEMC_VHDL_COMPATIBILITY
+    op->_address      = 0;
+#else
+  //op->_address      = 0;
+#endif
   };
 
@@ -693,5 +797,9 @@
     op->_exception    = EXCEPTION_ALU_NONE;
     op->_no_sequence  = 0;
-  //op->_address      = 0;
+#ifdef SYSTEMC_VHDL_COMPATIBILITY
+    op->_address      = 0;
+#else
+  //op->_address      = 0;
+#endif
   };
 
@@ -725,5 +833,9 @@
     op->_exception    = EXCEPTION_ALU_NONE;
     op->_no_sequence  = 0;
-  //op->_address      = 0;
+#ifdef SYSTEMC_VHDL_COMPATIBILITY
+    op->_address      = 0;
+#else
+  //op->_address      = 0;
+#endif
   };
 
@@ -757,5 +869,9 @@
     op->_exception    = EXCEPTION_ALU_NONE;
     op->_no_sequence  = 0;
-  //op->_address      = 0;
+#ifdef SYSTEMC_VHDL_COMPATIBILITY
+    op->_address      = 0;
+#else
+  //op->_address      = 0;
+#endif
   };
 
@@ -789,5 +905,9 @@
     op->_exception    = EXCEPTION_ALU_NONE;
     op->_no_sequence  = 0;
-  //op->_address      = 0;
+#ifdef SYSTEMC_VHDL_COMPATIBILITY
+    op->_address      = 0;
+#else
+  //op->_address      = 0;
+#endif
   };
 
@@ -912,5 +1032,9 @@
     op->_exception    = EXCEPTION_ALU_NONE;
     op->_no_sequence  = 0;
-  //op->_address      = 0;
+#ifdef SYSTEMC_VHDL_COMPATIBILITY
+    op->_address      = 0;
+#else
+  //op->_address      = 0;
+#endif
   };
 
@@ -936,5 +1060,9 @@
     op->_exception    = EXCEPTION_ALU_NONE;
     op->_no_sequence  = 0;
-  //op->_address      = 0;
+#ifdef SYSTEMC_VHDL_COMPATIBILITY
+    op->_address      = 0;
+#else
+  //op->_address      = 0;
+#endif
   };
 
@@ -960,5 +1088,9 @@
     op->_exception    = EXCEPTION_ALU_NONE;
     op->_no_sequence  = 0;
-  //op->_address      = 0;
+#ifdef SYSTEMC_VHDL_COMPATIBILITY
+    op->_address      = 0;
+#else
+  //op->_address      = 0;
+#endif
   };
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/SelfTest/mkf.info
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/SelfTest/mkf.info	(revision 116)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/SelfTest/mkf.info	(revision 116)
@@ -0,0 +1,11 @@
+
+# Functionnal_unit_0
+target_dep	all	Functionnal_unit_0.ngc
+target_dep	Functionnal_unit_0.ngc	Functionnal_unit_0.prj
+target_dep	Functionnal_unit_0.prj	Functionnal_unit_0_Pack.vhdl Functionnal_unit_0_shifter_Pack.vhdl Functionnal_unit_0_shifter.vhdl Functionnal_unit_0.vhdl
+
+# Functionnal_unit_1
+target_dep	all	Functionnal_unit_1.ngc
+target_dep	Functionnal_unit_1.ngc	Functionnal_unit_1.prj
+target_dep	Functionnal_unit_1.prj	Functionnal_unit_1_Pack.vhdl Functionnal_unit_1_shifter_Pack.vhdl Functionnal_unit_1_shifter.vhdl Functionnal_unit_1.vhdl
+
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/SelfTest/src/main.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/SelfTest/src/main.cpp	(revision 115)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/SelfTest/src/main.cpp	(revision 116)
@@ -60,5 +60,8 @@
 	timing[i][j]._delay = timing[i][j]._latence = 1;
     }
-
+  timing[4][1]._delay = 1;
+  timing[4][1]._latence = 7;
+  timing[4][2]._delay = 1;
+  timing[4][2]._latence = 7;
   try 
     {
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/SelfTest/src/test.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/SelfTest/src/test.cpp	(revision 115)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/SelfTest/src/test.cpp	(revision 116)
@@ -238,4 +238,6 @@
   
   transaction_in.push_back(execute_transaction(_param,0,0,0,  0,OPERATION_ALU_L_ADD     ,TYPE_ALU,0,0xdeadbeef,0x12344321,0x12345678,0              ,1,63,0x24689999,1,15,0              ,EXCEPTION_NONE     ,0));
+
+  
   transaction_in.push_back(execute_transaction(_param,0,0,0,  1,OPERATION_ALU_L_ADD     ,TYPE_ALU,0,0xffffffff,0x12345678,0x12345678,0              ,1,56,0x2468acf0,1,3 ,0              ,EXCEPTION_NONE     ,0));
   transaction_in.push_back(execute_transaction(_param,0,0,0,  2,OPERATION_ALU_L_ADD     ,TYPE_ALU,1,0x12345678,0x12345678,0xffffffff,0              ,1,56,0x2468acf0,1,3 ,0              ,EXCEPTION_NONE     ,0));
@@ -245,6 +247,6 @@
   transaction_in.push_back(execute_transaction(_param,0,0,0,  5,OPERATION_ALU_L_ADD     ,TYPE_ALU,1,0x80000000,0x80001000,0x0       ,0              ,1,1 ,0x1000    ,1,0 ,FLAG_CY|FLAG_OV,EXCEPTION_ALU_RANGE,0));
   transaction_in.push_back(execute_transaction(_param,0,0,0,  6,OPERATION_ALU_L_ADD     ,TYPE_ALU,1,0x7fffffff,0x00000001,0x0       ,FLAG_CY|FLAG_OV,1,1 ,0x80000000,1,0 ,        FLAG_OV,EXCEPTION_ALU_RANGE,0));
-							     			       
-							     			       
+  
+  
   transaction_in.push_back(execute_transaction(_param,0,0,0,  7,OPERATION_ALU_L_ADDC    ,TYPE_ALU,0,0xdeadbeef,0x12344321,0x12345678,0              ,1,63,0x24689999,1,15,0              ,EXCEPTION_NONE     ,0));
   transaction_in.push_back(execute_transaction(_param,0,0,0,  8,OPERATION_ALU_L_ADDC    ,TYPE_ALU,0,0xffffffff,0x12345678,0x12345678,0              ,1,56,0x2468acf0,1,3 ,0              ,EXCEPTION_NONE     ,0));
@@ -254,5 +256,5 @@
   transaction_in.push_back(execute_transaction(_param,0,0,0, 12,OPERATION_ALU_L_ADDC    ,TYPE_ALU,1,0x80000000,0x80001000,0x0       ,0              ,1,1 ,0x1000    ,1,0 ,FLAG_CY|FLAG_OV,EXCEPTION_ALU_RANGE,0));
   transaction_in.push_back(execute_transaction(_param,0,0,0, 13,OPERATION_ALU_L_ADDC    ,TYPE_ALU,1,0x7fffffff,0x00000001,0x0       ,0              ,1,1 ,0x80000000,1,0 ,        FLAG_OV,EXCEPTION_ALU_RANGE,0));
-							     			       
+  
   transaction_in.push_back(execute_transaction(_param,0,0,0, 14,OPERATION_ALU_L_ADDC    ,TYPE_ALU,0,0xdeadbeef,0x12344320,0x12345678,FLAG_CY        ,1,63,0x24689999,1,15,0              ,EXCEPTION_NONE     ,0));
   transaction_in.push_back(execute_transaction(_param,0,0,0, 15,OPERATION_ALU_L_ADDC    ,TYPE_ALU,0,0xffffffff,0x12345677,0x12345678,FLAG_CY        ,1,56,0x2468acf0,1,3 ,0              ,EXCEPTION_NONE     ,0));
@@ -262,25 +264,25 @@
   transaction_in.push_back(execute_transaction(_param,0,0,0, 19,OPERATION_ALU_L_ADDC    ,TYPE_ALU,1,0x80000000,0x8000000f,0x0       ,FLAG_CY        ,1,1 ,0x00000010,1,0 ,FLAG_CY|FLAG_OV,EXCEPTION_ALU_RANGE,0));
   transaction_in.push_back(execute_transaction(_param,0,0,0, 20,OPERATION_ALU_L_ADDC    ,TYPE_ALU,1,0x7fffffff,0x00000000,0x0       ,FLAG_CY        ,1,1 ,0x80000000,1,0 ,        FLAG_OV,EXCEPTION_ALU_RANGE,0));
-							     			       
-  							     			       
+  
+  
   transaction_in.push_back(execute_transaction(_param,0,0,0, 21,OPERATION_ALU_L_AND     ,TYPE_ALU,0,0xdeadbeef,0x0000ffff,0x00ff00ff,0              ,1,63,0x000000ff,0,15,FLAG_CY        ,EXCEPTION_NONE     ,0));
   transaction_in.push_back(execute_transaction(_param,0,0,0, 22,OPERATION_ALU_L_OR      ,TYPE_ALU,0,0xdeadbeef,0x0000ffff,0x00ff00ff,0              ,1,63,0x00ffffff,0,15,FLAG_CY        ,EXCEPTION_NONE     ,0));
   transaction_in.push_back(execute_transaction(_param,0,0,0, 23,OPERATION_ALU_L_XOR     ,TYPE_ALU,0,0xdeadbeef,0x0000ffff,0x00ff00ff,0              ,1,63,0x00ffff00,0,15,FLAG_CY        ,EXCEPTION_NONE     ,0));
-							     			       
+  
   transaction_in.push_back(execute_transaction(_param,0,0,0, 24,OPERATION_MOVE_L_CMOV    ,TYPE_MOVE,0,0x0       ,0xdeadbeef,0x12345678,0              ,1,63,0x12345678,0,15,FLAG_CY        ,EXCEPTION_NONE     ,0));
   transaction_in.push_back(execute_transaction(_param,0,0,0, 25,OPERATION_MOVE_L_CMOV    ,TYPE_MOVE,0,0x0       ,0xdeadbeef,0x12345678,FLAG_F         ,1,63,0xdeadbeef,0,15,FLAG_CY        ,EXCEPTION_NONE     ,0));
   transaction_in.push_back(execute_transaction(_param,0,0,0, 26,OPERATION_MOVE_L_MOVHI   ,TYPE_MOVE,1,0xdeadbeef,0x0       ,0x0       ,FLAG_F         ,1,63,0xbeef0000,0,15,FLAG_CY        ,EXCEPTION_NONE     ,0));
-							     			       
-							     			       
+  
+  
   transaction_in.push_back(execute_transaction(_param,0,0,0, 27,OPERATION_BRANCH_L_TEST_F  ,TYPE_BRANCH,1,0xdeadbeef,0x0       ,0x0       ,0              ,0,63,0xbeef0000,0,15,FLAG_CY        ,EXCEPTION_NONE     ,0,0x00000000));
   transaction_in.push_back(execute_transaction(_param,0,0,0, 28,OPERATION_BRANCH_L_TEST_F  ,TYPE_BRANCH,1,0xdeadbeef,0x0       ,0x0       ,FLAG_F         ,0,63,0xbeef0000,0,15,FLAG_CY        ,EXCEPTION_NONE     ,1,0xdeadbeef));
   transaction_in.push_back(execute_transaction(_param,0,0,0, 29,OPERATION_BRANCH_L_TEST_NF ,TYPE_BRANCH,1,0xdeadbeef,0x0       ,0x0       ,FLAG_F         ,0,63,0xbeef0000,0,15,FLAG_CY        ,EXCEPTION_NONE     ,0,0x00000000));
   transaction_in.push_back(execute_transaction(_param,0,0,0, 30,OPERATION_BRANCH_L_TEST_NF ,TYPE_BRANCH,1,0xdeadbeef,0x0       ,0x0       ,0              ,0,63,0xbeef0000,0,15,FLAG_CY        ,EXCEPTION_NONE     ,1,0xdeadbeef));
-							     			       
-  							     			       
+  
+  
   transaction_in.push_back(execute_transaction(_param,0,0,0, 31,OPERATION_BRANCH_L_JALR    ,TYPE_BRANCH,0,0xdeadbeef,0x0       ,0x12345678,0              ,0,63,0xdeadbeef,0,15,FLAG_CY        ,EXCEPTION_NONE     ,1,0x12345678>>2)); // jr
   transaction_in.push_back(execute_transaction(_param,0,0,0, 32,OPERATION_BRANCH_L_JALR    ,TYPE_BRANCH,1,0xdeadbeef,0x0       ,0x12345678,0              ,1,63,0xdeadbeef<<2,0,15,FLAG_CY        ,EXCEPTION_NONE     ,1,0x12345678>>2)); // jal
   transaction_in.push_back(execute_transaction(_param,0,0,0, 33,OPERATION_BRANCH_L_JALR    ,TYPE_BRANCH,1,0xdeadbeef,0x0       ,0x12345678,0              ,1,63,0xdeadbeef<<2,0,15,FLAG_CY        ,EXCEPTION_NONE     ,1,0x12345678>>2)); // jalr
-							     
+  
   transaction_in.push_back(execute_transaction(_param,0,0,0, 34,OPERATION_EXTEND_L_EXTEND_S,TYPE_EXTEND,1,8         ,0x12345678,0x0       ,0              ,1,63,0x00000078,0,15,FLAG_CY        ,EXCEPTION_NONE     ,0));
   transaction_in.push_back(execute_transaction(_param,0,0,0, 35,OPERATION_EXTEND_L_EXTEND_S,TYPE_EXTEND,1,16        ,0x12345678,0x0       ,0              ,1,63,0x00005678,0,15,FLAG_CY        ,EXCEPTION_NONE     ,0));
@@ -296,5 +298,5 @@
   transaction_in.push_back(execute_transaction(_param,0,0,0, 41,OPERATION_EXTEND_L_EXTEND_Z,TYPE_EXTEND,1,16        ,0xdeadbeef,0x0       ,0              ,1,63,0x0000beef,0,15,FLAG_CY        ,EXCEPTION_NONE     ,0));
   transaction_in.push_back(execute_transaction(_param,0,0,0, 42,OPERATION_EXTEND_L_EXTEND_Z,TYPE_EXTEND,1,32        ,0xdeadbeef,0x0       ,0              ,1,63,0xdeadbeef,0,15,FLAG_CY        ,EXCEPTION_NONE     ,0));
-							     
+  
   transaction_in.push_back(execute_transaction(_param,0,0,0, 43,OPERATION_SHIFT_L_SLL     ,TYPE_SHIFT,1,0         ,0xdeadbeef,0x0       ,0              ,1,63,0xdeadbeef,0,15,FLAG_CY        ,EXCEPTION_NONE     ,0));
   transaction_in.push_back(execute_transaction(_param,0,0,0, 44,OPERATION_SHIFT_L_SLL     ,TYPE_SHIFT,1,4         ,0xdeadbeef,0x0       ,0              ,1,63,0xeadbeef0,0,15,FLAG_CY        ,EXCEPTION_NONE     ,0));
@@ -344,5 +346,5 @@
   transaction_in.push_back(execute_transaction(_param,0,0,0, 88,OPERATION_SHIFT_L_ROR     ,TYPE_SHIFT,1,24        ,0x12345678,0x0       ,0              ,1,63,0x34567812,0,15,FLAG_CY        ,EXCEPTION_NONE     ,0));
   transaction_in.push_back(execute_transaction(_param,0,0,0, 89,OPERATION_SHIFT_L_ROR     ,TYPE_SHIFT,1,32        ,0x12345678,0x0       ,0              ,1,63,0x12345678,0,15,FLAG_CY        ,EXCEPTION_NONE     ,0));
-							     
+  
   transaction_in.push_back(execute_transaction(_param,0,0,0, 90,OPERATION_FIND_L_FF1     ,TYPE_FIND,0,0         ,0x12345678,0x0       ,0              ,1,63,4         ,0,15,FLAG_CY        ,EXCEPTION_NONE     ,0));
   transaction_in.push_back(execute_transaction(_param,0,0,0, 91,OPERATION_FIND_L_FF1     ,TYPE_FIND,0,0         ,0x0       ,0x0       ,0              ,1,63,0          ,0,15,FLAG_CY        ,EXCEPTION_NONE     ,0));
@@ -355,5 +357,5 @@
   transaction_in.push_back(execute_transaction(_param,0,0,0, 98,OPERATION_FIND_L_FL1     ,TYPE_FIND,0,0         ,0x1       ,0x0       ,0              ,1,63,1          ,0,15,FLAG_CY        ,EXCEPTION_NONE     ,0));
   transaction_in.push_back(execute_transaction(_param,0,0,0, 99,OPERATION_FIND_L_FL1     ,TYPE_FIND,0,0         ,0x80000000,0x0       ,0              ,1,63,32         ,0,15,FLAG_CY        ,EXCEPTION_NONE     ,0));
-
+  
   transaction_in.push_back(execute_transaction(_param,0,0,0,100,OPERATION_ALU_L_SUB     ,TYPE_ALU,0,0         ,0x12344321,0x1       ,0              ,1,63,0x12344320,1,15,0              ,EXCEPTION_NONE     ,0));
   transaction_in.push_back(execute_transaction(_param,0,0,0,101,OPERATION_ALU_L_SUB     ,TYPE_ALU,0,0         ,0x12345678,0xffffffff,0              ,1,56,0x12345679,1,3 ,0              ,EXCEPTION_NONE     ,0));
@@ -363,5 +365,5 @@
   transaction_in.push_back(execute_transaction(_param,0,0,0,105,OPERATION_ALU_L_SUB     ,TYPE_ALU,0,0         ,0x80001000,0x80000000,0              ,1,1 ,0x1000    ,1,0 ,        FLAG_OV,EXCEPTION_ALU_RANGE,0));
   transaction_in.push_back(execute_transaction(_param,0,0,0,106,OPERATION_ALU_L_SUB     ,TYPE_ALU,0,0         ,0x00000001,0x7fffffff,FLAG_CY|FLAG_OV,1,1 ,0x80000002,1,0 ,FLAG_CY        ,EXCEPTION_NONE     ,0));
-
+  
   transaction_in.push_back(execute_transaction(_param,0,0,0,120,OPERATION_TEST_L_SFEQ    ,TYPE_TEST,0,0         ,0xdead    ,0xdead    ,0              ,0,63,0x0       ,1,15,FLAG_F         ,EXCEPTION_NONE     ,0)); // + == +
   transaction_in.push_back(execute_transaction(_param,0,0,0,121,OPERATION_TEST_L_SFEQ    ,TYPE_TEST,0,0         ,0x25071959,0x21071981,0              ,0,63,0x0       ,1,15,0              ,EXCEPTION_NONE     ,0)); // + >  +
@@ -484,5 +486,5 @@
   transaction_in.push_back(execute_transaction(_param,0,0,0,300,OPERATION_TEST_L_SFLTS   ,TYPE_TEST,0,0         ,0x33333333,0xdeadbeef,0              ,0,63,0x0       ,1,15,0              ,EXCEPTION_NONE     ,0)); // + >  - (in unsigned)
   transaction_in.push_back(execute_transaction(_param,0,0,0,301,OPERATION_TEST_L_SFLTS   ,TYPE_TEST,0,0         ,0x11111111,0xdeadbeef,0              ,0,63,0x0       ,1,15,0              ,EXCEPTION_NONE     ,0)); // + <  - (in unsigned)
-
+  /*
   transaction_in.push_back(execute_transaction(_param,0,0,0,400,OPERATION_SPECIAL_L_MTSPR   ,TYPE_SPECIAL,1,GROUP_ICACHE<<11,   3,0xdeadbeef,0              ,0,63,0xdeadbeef,0, 0,0              ,EXCEPTION_ALU_SPR_ACCESS_MUST_WRITE  ,0,(GROUP_ICACHE<<11)|   3));
   transaction_in.push_back(execute_transaction(_param,0,0,0,401,OPERATION_SPECIAL_L_MTSPR   ,TYPE_SPECIAL,1,GROUP_ICACHE<<11,   5,0xdeadbeef,0              ,0,63,0xdeadbeef,0, 0,0              ,EXCEPTION_ALU_SPR_ACCESS_MUST_WRITE  ,0,(GROUP_ICACHE<<11)|   5));
@@ -568,5 +570,5 @@
   transaction_in.push_back(execute_transaction(_param,0,0,0,627,OPERATION_SPECIAL_L_MFSPR   ,TYPE_SPECIAL,1,GROUP_CUSTOM_7<<11, 0,0x0       ,0              ,1,63,0xe       ,0, 0,0              ,EXCEPTION_ALU_NONE                   ,0,(GROUP_CUSTOM_7<<11)|0));
   transaction_in.push_back(execute_transaction(_param,0,0,0,628,OPERATION_SPECIAL_L_MFSPR   ,TYPE_SPECIAL,1,GROUP_CUSTOM_7<<11, 0,0x0       ,0              ,1,63,0xa       ,0, 0,0              ,EXCEPTION_ALU_NONE                   ,0,(GROUP_CUSTOM_7<<11)|0));
-
+  */
   transaction_in.push_back(execute_transaction(_param,0,0,0,700,OPERATION_MUL_L_MUL     ,TYPE_MUL,0,0         ,0x00000001,0x00000001,0              ,1,63,0x00000001,1,15,0              ,EXCEPTION_NONE     ,0));
   transaction_in.push_back(execute_transaction(_param,0,0,0,701,OPERATION_MUL_L_MUL     ,TYPE_MUL,0,0         ,0x00002107,0x00001981,0              ,1,63,0x034a5387,1,15,0              ,EXCEPTION_NONE     ,0));
@@ -574,5 +576,5 @@
   transaction_in.push_back(execute_transaction(_param,0,0,0,703,OPERATION_MUL_L_MUL     ,TYPE_MUL,0,0         ,0x40000000,0x00000002,0              ,1,63,0x80000000,1,15,0              ,EXCEPTION_NONE     ,0));
   transaction_in.push_back(execute_transaction(_param,0,0,0,704,OPERATION_MUL_L_MUL     ,TYPE_MUL,0,0         ,0x40000000,0x00000004,0              ,1,63,0x00000000,1,15,FLAG_CY|FLAG_OV,EXCEPTION_ALU_RANGE,0));
-
+  
   transaction_in.push_back(execute_transaction(_param,0,0,0,800,OPERATION_MUL_L_MULU    ,TYPE_MUL,0,0         ,0x00000001,0x00000001,0              ,1,63,0x00000001,1,15,0              ,EXCEPTION_NONE     ,0));
   transaction_in.push_back(execute_transaction(_param,0,0,0,801,OPERATION_MUL_L_MULU    ,TYPE_MUL,0,0         ,0x00002107,0x00001981,0              ,1,63,0x034a5387,1,15,0              ,EXCEPTION_NONE     ,0));
@@ -580,5 +582,5 @@
   transaction_in.push_back(execute_transaction(_param,0,0,0,803,OPERATION_MUL_L_MULU    ,TYPE_MUL,0,0         ,0x40000000,0x00000002,0              ,1,63,0x80000000,1,15,0              ,EXCEPTION_NONE     ,0));
   transaction_in.push_back(execute_transaction(_param,0,0,0,804,OPERATION_MUL_L_MULU    ,TYPE_MUL,0,0         ,0x40000000,0x00000004,0              ,1,63,0x00000000,1,15,FLAG_CY|FLAG_OV,EXCEPTION_ALU_RANGE,0));
-
+  
 
 
@@ -602,5 +604,5 @@
       while (nb_transaction_out > 0)
       {
-	  Tcontrol_t val = ((rand()%100) < percent_transaction_execute_in) and not transaction_in.empty();
+        Tcontrol_t val = ((rand()%100) < percent_transaction_execute_in) and not transaction_in.empty() and transaction_out.empty();
 	  in_EXECUTE_IN_VAL .write(val);
 	  in_EXECUTE_OUT_ACK.write((rand()%100) < percent_transaction_execute_out);
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/include/Functionnal_unit.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/include/Functionnal_unit.h	(revision 115)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/include/Functionnal_unit.h	(revision 116)
@@ -17,10 +17,9 @@
 #include "Common/include/ToString.h"
 #include "Common/include/Debug.h"
-#include "Behavioural/include/Types.h"
 #include "Behavioural/include/Identification.h"
 
-#include "Behavioural/include/Types.h"
+#include "Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/Operation/include/Operation.h"
+#include "Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/include/Types.h"
 #include "Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/include/Parameters.h"
-#include "Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/Operation/include/Operation.h"
 #ifdef STATISTICS
 #include "Behavioural/include/Stat.h"
@@ -160,4 +159,5 @@
   public  : void        transition                (void);
   public  : void        genMoore                  (void);
+  public  : void        genMealy                  (void);
 
 #endif					       
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/include/Parameters.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/include/Parameters.h	(revision 115)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/include/Parameters.h	(revision 116)
@@ -11,4 +11,5 @@
 #include "Common/include/Debug.h"
 #include "Behavioural/include/Parameters.h"
+#include "Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/include/Types.h"
 #include "Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Execute_unit/Execute_unit/Functionnal_unit/Operation/include/Types.h"
 #include "Behavioural/Custom/include/Custom.h"
@@ -38,4 +39,5 @@
 //public : uint32_t            _size_store_queue             ;
 //public : uint32_t            _size_load_queue              ;
+  public : const Tfunctionnal_unit_scheme_t _functionnal_unit_scheme;
 
   public : execute_timing_t ** _timing                       ;
